import * as z from 'zod';
import { Prisma } from '../../../generated/prisma';
import Decimal from 'decimal.js';
import { IntFilterObjectSchema as IntFilterObjectSchema } from './IntFilter.schema';
import { StringNullableFilterObjectSchema as StringNullableFilterObjectSchema } from './StringNullableFilter.schema';
import { DecimalFilterObjectSchema as DecimalFilterObjectSchema } from './DecimalFilter.schema';
import { EnumPaymentMethodFilterObjectSchema as EnumPaymentMethodFilterObjectSchema } from './EnumPaymentMethodFilter.schema';
import { PaymentMethodSchema } from '../enums/PaymentMethod.schema';
import { DateTimeFilterObjectSchema as DateTimeFilterObjectSchema } from './DateTimeFilter.schema'

import { DecimalJSLikeSchema, isValidDecimalInput } from '../../helpers/decimal-helpers';
const servicelinetransactionscalarwhereinputSchema = z.object({
  AND: z.union([z.lazy(() => ServiceLineTransactionScalarWhereInputObjectSchema), z.lazy(() => ServiceLineTransactionScalarWhereInputObjectSchema).array()]).optional(),
  OR: z.lazy(() => ServiceLineTransactionScalarWhereInputObjectSchema).array().optional(),
  NOT: z.union([z.lazy(() => ServiceLineTransactionScalarWhereInputObjectSchema), z.lazy(() => ServiceLineTransactionScalarWhereInputObjectSchema).array()]).optional(),
  id: z.union([z.lazy(() => IntFilterObjectSchema), z.number().int()]).optional(),
  paymentId: z.union([z.lazy(() => IntFilterObjectSchema), z.number().int()]).optional(),
  serviceLineId: z.union([z.lazy(() => IntFilterObjectSchema), z.number().int()]).optional(),
  transactionId: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  paidAmount: z.union([z.lazy(() => DecimalFilterObjectSchema), z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'paidAmount' must be a Decimal",
})]).optional(),
  adjustedAmount: z.union([z.lazy(() => DecimalFilterObjectSchema), z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'adjustedAmount' must be a Decimal",
})]).optional(),
  method: z.union([z.lazy(() => EnumPaymentMethodFilterObjectSchema), PaymentMethodSchema]).optional(),
  receivedDate: z.union([z.lazy(() => DateTimeFilterObjectSchema), z.coerce.date()]).optional(),
  payerName: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  notes: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  createdAt: z.union([z.lazy(() => DateTimeFilterObjectSchema), z.coerce.date()]).optional()
}).strict();
export const ServiceLineTransactionScalarWhereInputObjectSchema: z.ZodType<Prisma.ServiceLineTransactionScalarWhereInput> = servicelinetransactionscalarwhereinputSchema as unknown as z.ZodType<Prisma.ServiceLineTransactionScalarWhereInput>;
export const ServiceLineTransactionScalarWhereInputObjectZodSchema = servicelinetransactionscalarwhereinputSchema;
